//'use strict';

// Выбор типа сервера.  Если скрипт будет работать в Win серде (в программе на NWJS), тогда задействуем некоторые функции
// И подключим пару скриптов через стандартный тег <script> в индексном файле, т.к. их невозможно установить вчерез npm -install без танцев с бубном
var servertype = "win";

try  {
	Framework7.device.nwjs;
	console.log ('win like os')
} catch (e) {
	servertype = "nix";
	console.log ('nix like os')
}

if (servertype == "nix") {
	var myapp = {
		serverstats : {requestcount : 0, errorcount : 0},
		serverlogs : [{event: 'start logs...', status: 'started successful'}],
	}
	
	var GLOBALSTN = {
		mngrMailSettings : {
			host: 'smtp.mail.ru',
			port: 465,
			user: 'e@bk.ru',
			pass: '7',
			from : '"My cafe " <e@bk.ru',
			to : "e@bk.ru",
			subject : "Новый заказ"
	   	},
	  	pounchdbserver : 'localhost:5984',
	  
	  	pounchdbserver_adminlogin : 'admin',
	  	pounchdbserver_adminpsw : 'psw',
	  
	  	requiredbasedoc : ['categories0', 'categories', 'products', 'promo']
  };
}

const express = require('express');
const SocketServer = require('ws').Server;
const path = require('path');
const fs = require("fs");
var requestmod = require('request');
const https = require('https')
	if (servertype == "nix") {
		// в win версии подключаются из my-app.js
	var PouchDB = require('pouchdb');
	PouchDB.plugin(require('pouchdb-authentication'));
	}
var md5 = require('md5');
const nodemailer = require('nodemailer');

// Делаем сервак
/*
const PORT = process.env.PORT || 3000;
const INDEX = path.join(__dirname, 'index.html');

const server = express()
  .use((req, res) => res.sendFile(INDEX) )
  .listen(PORT, () => console.log(`Listening on ${ PORT }`));
*/


 
const app = express();

const timeoptions = {
	year: 'numeric',
	month: 'long',
	day: 'numeric',
	weekday: 'long',
	timezone: 'UTC',
	hour: 'numeric',
	minute: 'numeric',
	second: 'numeric'
  };


function statsAndLogs (logsevent, result) {
	var d = new Date();
	myapp.serverlogs.unshift ({event: logsevent, status: result+'  -  '+ d.toLocaleString("ru", timeoptions)})
	if (myapp.serverlogs.length > 9) {
		myapp.serverlogs.length = 10;
	}
	
	myapp.serverstats.requestcount += 1;

	if (result == 'error') {
		myapp.serverstats.errorcount += 1;
	}
}

///////////////////////////////////////////////////S:  Отправка заявок ........................................  
// async..await is not allowed in global scope, must use a wrapper
async function sendOrderRequestToMngrEmail(neworder_operations) {
 

	// create reusable transporter object using the default SMTP transport
	let transporter = nodemailer.createTransport({
		host: GLOBALSTN.mngrMailSettings.host,
		port: GLOBALSTN.mngrMailSettings.port,
		secure: true,
		auth: {
		  user: GLOBALSTN.mngrMailSettings.user,
		  pass: GLOBALSTN.mngrMailSettings.pass
		},
  
	  });
  
	 
	  console.log (neworder_operations.basket)

	  var orderdetailtomail = `<div>Дата доставки: ${neworder_operations.basket.delevery.time}</div>`;
		  orderdetailtomail += `<div>Итоговая сумма: ${neworder_operations.basket.totalsum}</div>`;
		  
		  

		  var d = new Date();
		  d = d.toLocaleString("ru", timeoptions)
	  let info = await transporter.sendMail({
		from: GLOBALSTN.mngrMailSettings.from,
		to: GLOBALSTN.mngrMailSettings.to,
		subject: GLOBALSTN.mngrMailSettings.subject,
		//text: "This message was sent from Node js server.",
		html: `Поступил новый заказ от <strong>${d}</strong> Детали <br>: ${orderdetailtomail}`
	  });
  
  
	console.log("Message sent: %s", info.messageId);
	// Message sent: <b658f8ca-6296-ccf4-8306-87d57a0b4321@example.com>
  
  }
  
 var sendOrderRequestToMngrEmail_ok = (ok)=> {
	 console.log ('SENDING_OK')
	

	 statsAndLogs('send email...','successful');

	}


 var sendOrderRequestToMngrEmail_reject = (err)=> {console.log ('SENDING_BAD'); console.log(err)

 			statsAndLogs('send email...','error');
			

}
///////////////////////////////////////////////////E:  Отправка заявок ........................................  


app.use(function(req, res, next) {
  res.header("Access-Control-Allow-Origin", "*");
  res.header("Access-Control-Allow-Headers", "Origin, X-Requested-With, Content-Type, Accept");
  next();
});

app.get("/", function(request, response){
	
	statsAndLogs('ping pong...','successful');

     var nodejssrvStatus = {
		 status : 'work'
	 }
    response.json (nodejssrvStatus)
});

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////S:  Новый заказ //////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

app.get("/neworder", function(request, response){
     
	 console.log (request.query)
	// Переменная в которую записываем результат оформления заказа поэтапно
	var neworder_operations = {
		bdresponse : [], // Ответ от БД couchbd
		
		isusrok : false, // Юзер существует в базе (а-то малоли что)
		//order : false,  // Поместим заказ в БД для обработки менеджорами
		allok : 0, // Счётчик, если все цепочки успешно выполнилис будет равен 4 (4 успшных этапа)
		neworder: 'not ok'
	};
	
	
	
	
	// Финальный RESOLVE -отправляет ок в моб прил, если база збс создана
	var resolve = (neworder_operations)=> {
		
		if (neworder_operations.allok == 'ok') {

			var d = new Date();
			myapp.serverlogs.unshift ({event: 'new order...', status: 'successful'+'  -  '+ d.toLocaleString("ru", timeoptions)})
			if (myapp.serverlogs.length > 9) {
				myapp.serverlogs.length = 10;
			}
			myapp.serverstats.requestcount += 1;


			neworder_operations.neworderadd = "complite" // Запись заказа завершена

			// письмо
			sendOrderRequestToMngrEmail(neworder_operations).then(sendOrderRequestToMngrEmail_ok).catch(sendOrderRequestToMngrEmail_reject);
		}
		console.log(neworder_operations)
		response.json (neworder_operations);
	}
	
	// Один на всех - в случае ошибки отправляет мобильному приложения ошибку
	var reject = (neworder_operations)=> {

		var d = new Date();
		myapp.serverlogs.unshift ({event: 'new order...', status: 'fail'+'  -  '+ d.toLocaleString("ru", timeoptions)})
		if (myapp.serverlogs.length > 9) {
			myapp.serverlogs.length = 10;
		}
		myapp.serverstats.requestcount += 1;
		myapp.serverstats.errorcount += 1;


		console.log(neworder_operations)
		response.json (neworder_operations);
	}
	
	// Записываем в админскую базу информацию о новом заказе
	const putNewOrderToAdminBase = () => new Promise ((resolve, reject)=>{
			
			    let login = '';
				let psw = '';
				
				var base_id_hash = login+psw;
				//Получим логина и пароля из строки запроса
				base_id_hash = md5(base_id_hash);
				//var pounchdbserver = '94.123.45.88:5984';
				GLOBALSTN.pounchdbserver_adminpsw
				GLOBALSTN.pounchdbserver_adminlogin
				
				// adm_login:adm_psw@localhost:5984

				// '+GLOBALSTN.pounchdbserver_adminlogin+':'+GLOBALSTN.pounchdbserver_adminpsw+'@'+GLOBALSTN.pounchdbserver+
				
			
				var nowbase =  new PouchDB('http://'+GLOBALSTN.pounchdbserver_adminlogin+':'+GLOBALSTN.pounchdbserver_adminpsw+'@'+GLOBALSTN.pounchdbserver+'/user_'+base_id_hash, {skip_setup: false});
				
				// В базе админа содержатся документы с id == хешам юзеров. Они содержат данные по заказам для кадого юзера
				var userorder_base_id_hash = request.query.orderuser_login+request.query.orderuser_psw;
				userorder_base_id_hash =  md5(userorder_base_id_hash);
				
					nowbase.get('user_'+userorder_base_id_hash).then(function(doc) {
					
					// Если она есть добавим в него ещё один заказ
					console.log (doc)
					
					doc.count = Number.parseInt(doc.count) + 1;
					  doc.orderStatus = 'new';
					  doc.basket = request.query.order_info;
					  doc.usercontactinfo = request.query.orderuser_usercontactinfo
					   nowbase.put(
						  doc
						).then(function (response) {
							
						neworder_operations.allok = 'ok';
						neworder_operations.neworder = 'ok';
						neworder_operations.basket = request.query.order_info  // для того что бы передать на почту
						
						  resolve(neworder_operations);
						}).catch(function (err) {
						  console.log(err);
						  reject(neworder_operations);
						});

					}).then(function(response) {
						
						console.log (response)
						
					}).catch(function (err) {
						
					  console.log('Создадим id == order!')
					  console.log (err)
					  // Если нет - добавим -Создадим id == order и поместим первый заказ
					  
					 let doc = {
						 _id : 'user_'+userorder_base_id_hash,
						 count : '1',
						 orderStatus : 'new',
						 basket : request.query.order_info,
						 usercontactinfo : request.query.orderuser_usercontactinfo
					 }
					  
					  	nowbase.put(
						  doc
						).then(function (response) {
							
						neworder_operations.allok = 'ok';
						neworder_operations.neworder = 'ok';
						
						  resolve(neworder_operations);
						}).catch(function (err) {
						  console.log(err);
						  reject(neworder_operations);
						});
	
					});
				
				
			
				// Получим таблицу (документ) заказов. Таблица хранится в админской базе (в базе суперадмина).
				//	Она такая же как и у других пользователей (таблица, документ).  Т.е. имеет такую же структуру (корзина, но кроме этого там есть документ order, который содержит заказы)
				/*
				nowbase.get('orders').then(function(doc) {
					
					// Если она есть добавим в него ещё один заказ
					console.log (doc)
					
					doc.count = Number.parseInt(doc.count) + 1;
					  
					   nowbase.put(
						  doc
						).then(function (response) {
							
						neworder_operations.allok = 'ok';
						neworder_operations.neworder = 'ok';
						
						  resolve(neworder_operations);
						}).catch(function (err) {
						  console.log(err);
						  reject(neworder_operations);
						});

					}).then(function(response) {
						
						console.log (response)
						
					}).catch(function (err) {
						
					  console.log('Создадим id == order!')
					  console.log (err)
					  // Если нет - добавим -Создадим id == order и поместим первый заказ
					  
					 let doc = {
						 _id : 'orders',
						 count : '1'
					 }
					  
					  	nowbase.put(
						  doc
						).then(function (response) {
							
						neworder_operations.allok = 'ok';
						neworder_operations.neworder = 'ok';
						
						  resolve(neworder_operations);
						}).catch(function (err) {
						  console.log(err);
						  reject(neworder_operations);
						});
	
					});
					*/
					

			
		}) // EoF: putNewOrderToAdminBase
	
	
	// Цепочка промисов по регистрации
	putNewOrderToAdminBase().then(resolve).catch(reject);
	

	
});
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////E:  Новый заказ //////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Регистрация нового пользователя
app.get("/newreg", function(request, response){
	
	// Переменная в которую записываем результат регистрации поэтапно
	var regoperations = {
		bdresponse : [], // Ответ от БД couchbd
		
		newusr : false, // Изер создан
		newbd : false, // База создана
		addadmin : false,
		allok : 0, // Счётчик, если все цепочки успешно выполнилис будет равен 4 (4 успшных этапа)
		registration: 'not complite'
	};
	
	//0 
	// Получаем от мобильного  логин и пароль...
	// Генерируем случайное сложное имя базы
	var psw = request.query.psw;
	var login = request.query.login
	
	var base_id_hash = login+psw;
	
	//Получим логина и пароля из строки запроса
	base_id_hash = md5(base_id_hash);
	
	
	// Финальный RESOLVE -отправляет ок в моб прил, если база збс создана
	var resolve = (regoperations)=> {
		
		if (regoperations.allok == 3) {

			var d = new Date();
			myapp.serverlogs.unshift ({event: 'new user...', status: 'successful'+'  -  '+ d.toLocaleString("ru", timeoptions)})
			if (myapp.serverlogs.length > 9) {
				myapp.serverlogs.length = 10;
			}
			myapp.serverstats.requestcount += 1;


			regoperations.registration = "complite"
		}
		console.log(regoperations)
		response.json (regoperations);
	}
	
	// Один на всех - в случае ошибки отправляет мобильному приложения ошибку
	var reject = (regoperations)=> {

		var d = new Date();
		myapp.serverlogs.unshift ({event: 'new user...', status: 'fail'+'  -  '+ d.toLocaleString("ru", timeoptions)})
		if (myapp.serverlogs.length > 9) {
			myapp.serverlogs.length = 10;
		}
		myapp.serverstats.requestcount += 1;
		myapp.serverstats.errorcount += 1;

		console.log(regoperations)
		response.json (regoperations);
	}
	
	
		// 1
		// Создаём нового юзера через плагин  юзер аутентификатион - он нормас так создаёт юзеров
		const addNewUsrToBase = () => new Promise ((resolve, reject)=>{
			var newregbasenow =  new PouchDB('http://'+GLOBALSTN.pounchdbserver_adminlogin+':'+GLOBALSTN.pounchdbserver_adminpsw+'@'+GLOBALSTN.pounchdbserver+'/user_'+base_id_hash, {skip_setup: false});
			
			// Используем логин и пароль полученные от приложения
			newregbasenow.signUp(login, psw, function (err, res) {
			  if (err) {
				if (err.name === 'conflict') {
					regoperations.newusr = 'user_already_exists';
				  // "batman" already exists, choose another username
				} else if (err.name === 'forbidden') {
				  // invalid username
				  regoperations.newusr = 'invalid_username';
				} else {
				  // HTTP error, cosmic rays, etc.
				}
				
				regoperations.newbd = 'err newUser NOT created';
				regoperations.bdresponse.push ( err );
				reject(regoperations)
				
			  } else {
					regoperations.newusr = 'ok - newUser created';
					regoperations.allok++;
					regoperations.bdresponse.push ( res );
							
					resolve(regoperations);
			  }
			});
			
			
			
		});
		
	
		// 2
		// Создаём новую базу для пользователя (Через учётку "суперадмина")
		const createnewbd = () => new Promise ((resolve, reject)=>{
			
		var options = {
			url : 'http://'+GLOBALSTN.pounchdbserver_adminlogin+':'+GLOBALSTN.pounchdbserver_adminpsw+'@'+GLOBALSTN.pounchdbserver+'/user_'+base_id_hash,
			method : 'PUT',
		}

		requestmod( options, function(err, res, html){
			if(err){
				
				response.json (err);
				reject(err)
				
			} else {
				
				// Ответ базы на попытку создания
				//console.log(html)
				html = JSON.parse(html);
				// Если база создана без ошибок
				if (!html.error && html.ok == true) {
					regoperations.newbd = 'ok - bd created';
					regoperations.allok++;
					regoperations.bdresponse.push ( html );
					
					
					// Вызываем вторую стадию цепочки
					resolve(regoperations);
				
				// Если ошибка при создании базы
				} else {
					
					regoperations.newbd = 'err bd NOT created';
					regoperations.bdresponse.push ( html );
					
					// Завершаем впромисы, т.к. базу невозможно создать, и отправляем в моб.прил ошибку
					reject(regoperations)
					
				}
			
			
			}
			
		}
		)
			
		})
		
		
		
		
		
	
			
		
		// 3
		// ПриХуярим  юзера к базе	
		// http://94.88.87.88:5984/batmanbase/_security
		
		const addAdmintoBase = ()=> new Promise ((resolve, reject)=>{
			
			var options = {
				url : 'http://'+GLOBALSTN.pounchdbserver_adminlogin+':'+GLOBALSTN.pounchdbserver_adminpsw+'@'+GLOBALSTN.pounchdbserver+'/user_'+base_id_hash+'/_security',
				method : 'PUT',
			
				body: JSON.stringify({admins: {
						names: [login],
						roles: []
					},
					members: {
						names: [login],
						roles: []
					}
				}
				)	 
			} // E: options
			
			requestmod( options, function(err, res, html){
				if(err){
					regoperations.addadmin = 'err - admin NOT added to base';
					regoperations.bdresponse.push ( err );
					reject(regoperations);
					
				}else {
					html = JSON.parse(html);
					// Если база создана без ошибок
					if (!html.error && html.ok == true) {
						regoperations.addadmin = 'ok - admin added to base';
						regoperations.allok++;
						regoperations.bdresponse.push ( html );
								
						resolve(regoperations);
					}else {
							regoperations.addadmin = 'err - admin NOT added to base';
							regoperations.bdresponse.push ( html );
							reject(regoperations);
					}
				}
		
			})
			
		})
		
		
		// Цепочка промисов по регистрации
		addNewUsrToBase().then(createnewbd).then(addAdmintoBase).then(resolve).catch(reject);
		
			
	

});
app.get("/fb", function(request, response){
	
	var dbremote = new PouchDB('http://'+GLOBALSTN.pounchdbserver_adminlogin+':'+GLOBALSTN.pounchdbserver_adminpsw+'@'+GLOBALSTN.pounchdbserver+'/users/');
	
	
			dbremote.allDocs({
			  include_docs: true,
			  attachments: true
			}).then(function (result) {
			 response.send (result)
			}).catch(function (err) {
			  response.send(err);
			});

  
    //response.send("<h1>Контакты</h1>");
	
	
});
app.listen(5000);


////////  Тут будут всякие функции .................

// E : Тут будут всякие функции